var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
import { createContext, createRoot, createRenderEffect, createComponent as createComponent$1, mergeProps as mergeProps$2, createMemo, useContext, createEffect, splitProps, untrack, createSignal, createComputed, onCleanup } from "solid-js";
export * from "solid-js";
import * as THREE from "three";
import { Scene } from "three";
import create from "zustand/vanilla";
import { template, insert as insert$1, effect as effect$1, setAttribute, createComponent as createComponent$2 } from "solid-js/web";
const subscribeWithSelector = (fn) => (set, get, api) => {
  const origSubscribe = api.subscribe;
  api.subscribe = (selector, optListener, options) => {
    let listener = selector;
    if (optListener) {
      const equalityFn = (options == null ? void 0 : options.equalityFn) || Object.is;
      let currentSlice = selector(api.getState());
      listener = (state) => {
        const nextSlice = selector(state);
        if (!equalityFn(currentSlice, nextSlice)) {
          const previousSlice = currentSlice;
          optListener(currentSlice = nextSlice, previousSlice);
        }
      };
      if (options == null ? void 0 : options.fireImmediately) {
        optListener(currentSlice, currentSlice);
      }
    }
    return origSubscribe(listener);
  };
  const initialState = fn(set, get, api);
  return initialState;
};
const isRenderer = (def) => !!(def == null ? void 0 : def.render);
const isOrthographicCamera = (def) => def && def.isOrthographicCamera;
const ThreeContext = createContext(null);
const createThreeStore = (applyProps2, invalidate2, advance2, props) => {
  const {
    gl,
    size,
    shadows = false,
    linear = false,
    flat = false,
    orthographic = false,
    frameloop = "always",
    dpr = [1, 2],
    performance,
    clock = new THREE.Clock(),
    raycaster: raycastOptions,
    camera: cameraOptions,
    onPointerMissed
  } = props;
  if (shadows) {
    gl.shadowMap.enabled = true;
    if (typeof shadows === "object")
      Object.assign(gl.shadowMap, shadows);
    else
      gl.shadowMap.type = THREE.PCFSoftShadowMap;
  }
  if (linear)
    gl.outputEncoding = THREE.LinearEncoding;
  if (flat)
    gl.toneMapping = THREE.NoToneMapping;
  if (frameloop === "never") {
    clock.stop();
    clock.elapsedTime = 0;
  }
  const rootState = create(subscribeWithSelector((set, get) => {
    const raycaster = new THREE.Raycaster();
    const _a = raycastOptions || {}, { params } = _a, options = __objRest(_a, ["params"]);
    applyProps2(raycaster, __spreadProps(__spreadValues({
      enabled: true
    }, options), {
      params: __spreadValues(__spreadValues({}, raycaster.params), params)
    }));
    const isCamera = cameraOptions instanceof THREE.Camera;
    const camera = isCamera ? cameraOptions : orthographic ? new THREE.OrthographicCamera(0, 0, 0, 0, 0.1, 1e3) : new THREE.PerspectiveCamera(75, 0, 0.1, 1e3);
    if (!isCamera) {
      camera.position.z = 5;
      if (cameraOptions)
        applyProps2(camera, cameraOptions);
      if (!(cameraOptions == null ? void 0 : cameraOptions.rotation))
        camera.lookAt(0, 0, 0);
    }
    const initialDpr = calculateDpr(dpr);
    const position = new THREE.Vector3();
    const defaultTarget = new THREE.Vector3();
    const tempTarget = new THREE.Vector3();
    function getCurrentViewport(camera2 = get().camera, target = defaultTarget, size2 = get().size) {
      const { width, height } = size2;
      const aspect = width / height;
      if (target instanceof THREE.Vector3)
        tempTarget.copy(target);
      else
        tempTarget.set(...target);
      const distance = camera2.getWorldPosition(position).distanceTo(tempTarget);
      if (isOrthographicCamera(camera2)) {
        return {
          width: width / camera2.zoom,
          height: height / camera2.zoom,
          factor: 1,
          distance,
          aspect
        };
      } else {
        const fov = camera2.fov * Math.PI / 180;
        const h = 2 * Math.tan(fov / 2) * distance;
        const w = h * (width / height);
        return { width: w, height: h, factor: width / w, distance, aspect };
      }
    }
    let performanceTimeout = void 0;
    const setPerformanceCurrent = (current) => set((state2) => ({ performance: __spreadProps(__spreadValues({}, state2.performance), { current }) }));
    const handleXRFrame = (timestamp) => {
      const state2 = get();
      if (state2.frameloop === "never")
        return;
      advance2(timestamp, true);
    };
    const handleSessionChange = () => {
      gl.xr.enabled = gl.xr.isPresenting;
      gl.setAnimationLoop(gl.xr.isPresenting ? handleXRFrame : null);
      if (!gl.xr.isPresenting)
        invalidate2(get());
    };
    const xr = {
      connect() {
        gl.xr.addEventListener("sessionstart", handleSessionChange);
        gl.xr.addEventListener("sessionend", handleSessionChange);
      },
      disconnect() {
        gl.xr.removeEventListener("sessionstart", handleSessionChange);
        gl.xr.removeEventListener("sessionend", handleSessionChange);
      }
    };
    if (gl.xr)
      xr.connect();
    return {
      gl,
      set,
      get,
      invalidate: () => invalidate2(get()),
      advance: (timestamp, runGlobalEffects) => advance2(timestamp, runGlobalEffects, get()),
      linear,
      flat,
      scene: prepare(new THREE.Scene()),
      camera,
      controls: null,
      raycaster,
      clock,
      mouse: new THREE.Vector2(),
      frameloop,
      onPointerMissed,
      performance: __spreadProps(__spreadValues({
        current: 1,
        min: 0.5,
        max: 1,
        debounce: 200
      }, performance), {
        regress: () => {
          const state2 = get();
          if (performanceTimeout)
            clearTimeout(performanceTimeout);
          if (state2.performance.current !== state2.performance.min)
            setPerformanceCurrent(state2.performance.min);
          performanceTimeout = setTimeout(() => setPerformanceCurrent(get().performance.max), state2.performance.debounce);
        }
      }),
      size: { width: 800, height: 600 },
      viewport: {
        initialDpr,
        dpr: initialDpr,
        width: 0,
        height: 0,
        aspect: 0,
        distance: 0,
        factor: 0,
        getCurrentViewport
      },
      setSize: (width, height) => {
        const size2 = { width, height };
        set((state2) => ({
          size: size2,
          viewport: __spreadValues(__spreadValues({}, state2.viewport), getCurrentViewport(camera, defaultTarget, size2))
        }));
      },
      setDpr: (dpr2) => set((state2) => ({
        viewport: __spreadProps(__spreadValues({}, state2.viewport), { dpr: calculateDpr(dpr2) })
      })),
      setFrameloop: (frameloop2 = "always") => set(() => ({ frameloop: frameloop2 })),
      events: { connected: false },
      internal: {
        active: false,
        priority: 0,
        frames: 0,
        lastProps: props,
        lastEvent: { current: null },
        interaction: [],
        hovered: new Map(),
        subscribers: [],
        initialClick: [0, 0],
        initialHits: [],
        capturedMap: new Map(),
        xr,
        subscribe: (ref, priority = 0) => {
          set(({ internal }) => ({
            internal: __spreadProps(__spreadValues({}, internal), {
              priority: internal.priority + (priority > 0 ? 1 : 0),
              subscribers: [...internal.subscribers, { ref, priority }].sort((a, b) => a.priority - b.priority)
            })
          }));
          return () => {
            set(({ internal }) => ({
              internal: __spreadProps(__spreadValues({}, internal), {
                priority: internal.priority - (priority > 0 ? 1 : 0),
                subscribers: internal.subscribers.filter((s) => s.ref !== ref)
              })
            }));
          };
        }
      }
    };
  }));
  const state = rootState.getState();
  let oldSize = state.size;
  let oldDpr = state.viewport.dpr;
  rootState.subscribe(() => {
    const { camera, size: size2, viewport, internal } = rootState.getState();
    if (size2 !== oldSize || viewport.dpr !== oldDpr) {
      if (!camera.manual && !(internal.lastProps.camera instanceof THREE.Camera)) {
        if (isOrthographicCamera(camera)) {
          camera.left = size2.width / -2;
          camera.right = size2.width / 2;
          camera.top = size2.height / 2;
          camera.bottom = size2.height / -2;
        } else {
          camera.aspect = size2.width / size2.height;
        }
        camera.updateProjectionMatrix();
        camera.updateMatrixWorld();
      }
      gl.setPixelRatio(viewport.dpr);
      gl.setSize(size2.width, size2.height);
      oldSize = size2;
      oldDpr = viewport.dpr;
    }
  });
  if (size)
    state.setSize(size.width, size.height);
  rootState.subscribe((state2) => invalidate2(state2));
  return rootState;
};
function memo$1(fn, equals) {
  return createMemo(fn, void 0, !equals ? {
    equals
  } : void 0);
}
function createRenderer$1({
  createElement: createElement2,
  createTextNode: createTextNode2,
  isTextNode,
  replaceText,
  insertNode: insertNode2,
  removeNode,
  setProperty,
  getParentNode,
  getFirstChild,
  getNextSibling
}) {
  function insert2(parent, accessor, marker, initial) {
    if (marker !== void 0 && !initial)
      initial = [];
    if (typeof accessor !== "function")
      return insertExpression(parent, accessor, initial, marker);
    createRenderEffect((current) => insertExpression(parent, accessor(), current, marker), initial);
  }
  function insertExpression(parent, value, current, marker, unwrapArray) {
    while (typeof current === "function")
      current = current();
    if (value === current)
      return current;
    const t = typeof value, multi = marker !== void 0;
    if (t === "string" || t === "number") {
      if (t === "number")
        value = value.toString();
      if (multi) {
        let node = current[0];
        if (node && isTextNode(node)) {
          replaceText(node, value);
        } else
          node = createTextNode2(value);
        current = cleanChildren(parent, current, marker, node);
      } else {
        if (current !== "" && typeof current === "string") {
          replaceText(getFirstChild(parent), current = value);
        } else {
          cleanChildren(parent, current, marker, createTextNode2(value));
          current = value;
        }
      }
    } else if (value == null || t === "boolean") {
      current = cleanChildren(parent, current, marker);
    } else if (t === "function") {
      createRenderEffect(() => {
        let v = value();
        while (typeof v === "function")
          v = v();
        current = insertExpression(parent, v, current, marker);
      });
      return () => current;
    } else if (Array.isArray(value)) {
      const array = [];
      if (normalizeIncomingArray(array, value, unwrapArray)) {
        createRenderEffect(() => current = insertExpression(parent, array, current, marker, true));
        return () => current;
      }
      if (array.length === 0) {
        const replacement = cleanChildren(parent, current, marker);
        if (multi)
          return current = replacement;
      } else {
        if (Array.isArray(current)) {
          if (current.length === 0) {
            appendNodes(parent, array, marker);
          } else
            reconcileArrays(parent, current, array);
        } else if (current == null || current === "") {
          appendNodes(parent, array);
        } else {
          reconcileArrays(parent, multi && current || [getFirstChild(parent)], array);
        }
      }
      current = array;
    } else {
      if (Array.isArray(current)) {
        if (multi)
          return current = cleanChildren(parent, current, marker, value);
        cleanChildren(parent, current, null, value);
      } else if (current == null || current === "" || !getFirstChild(parent)) {
        insertNode2(parent, value);
      } else
        replaceNode(parent, value, getFirstChild(parent));
      current = value;
    }
    return current;
  }
  function normalizeIncomingArray(normalized, array, unwrap) {
    let dynamic = false;
    for (let i2 = 0, len = array.length; i2 < len; i2++) {
      let item = array[i2], t;
      if (item == null || item === true || item === false)
        ;
      else if (Array.isArray(item)) {
        dynamic = normalizeIncomingArray(normalized, item) || dynamic;
      } else if ((t = typeof item) === "string" || t === "number") {
        normalized.push(createTextNode2(item));
      } else if (t === "function") {
        if (unwrap) {
          while (typeof item === "function")
            item = item();
          dynamic = normalizeIncomingArray(normalized, Array.isArray(item) ? item : [item]) || dynamic;
        } else {
          normalized.push(item);
          dynamic = true;
        }
      } else
        normalized.push(item);
    }
    return dynamic;
  }
  function reconcileArrays(parentNode, a, b) {
    let bLength = b.length, aEnd = a.length, bEnd = bLength, aStart = 0, bStart = 0, after = getNextSibling(a[aEnd - 1]), map = null;
    while (aStart < aEnd || bStart < bEnd) {
      if (a[aStart] === b[bStart]) {
        aStart++;
        bStart++;
        continue;
      }
      while (a[aEnd - 1] === b[bEnd - 1]) {
        aEnd--;
        bEnd--;
      }
      if (aEnd === aStart) {
        const node = bEnd < bLength ? bStart ? getNextSibling(b[bStart - 1]) : b[bEnd - bStart] : after;
        while (bStart < bEnd)
          insertNode2(parentNode, b[bStart++], node);
      } else if (bEnd === bStart) {
        while (aStart < aEnd) {
          if (!map || !map.has(a[aStart]))
            removeNode(parentNode, a[aStart]);
          aStart++;
        }
      } else if (a[aStart] === b[bEnd - 1] && b[bStart] === a[aEnd - 1]) {
        const node = getNextSibling(a[--aEnd]);
        insertNode2(parentNode, b[bStart++], getNextSibling(a[aStart++]));
        insertNode2(parentNode, b[--bEnd], node);
        a[aEnd] = b[bEnd];
      } else {
        if (!map) {
          map = new Map();
          let i2 = bStart;
          while (i2 < bEnd)
            map.set(b[i2], i2++);
        }
        const index = map.get(a[aStart]);
        if (index != null) {
          if (bStart < index && index < bEnd) {
            let i2 = aStart, sequence = 1, t;
            while (++i2 < aEnd && i2 < bEnd) {
              if ((t = map.get(a[i2])) == null || t !== index + sequence)
                break;
              sequence++;
            }
            if (sequence > index - bStart) {
              const node = a[aStart];
              while (bStart < index)
                insertNode2(parentNode, b[bStart++], node);
            } else
              replaceNode(parentNode, b[bStart++], a[aStart++]);
          } else
            aStart++;
        } else
          removeNode(parentNode, a[aStart++]);
      }
    }
  }
  function cleanChildren(parent, current, marker, replacement) {
    if (marker === void 0) {
      let removed;
      while (removed = getFirstChild(parent))
        removeNode(parent, removed);
      replacement && insertNode2(parent, replacement);
      return "";
    }
    const node = replacement || createTextNode2("");
    if (current.length) {
      let inserted = false;
      for (let i2 = current.length - 1; i2 >= 0; i2--) {
        const el = current[i2];
        if (node !== el) {
          const isParent = getParentNode(el) === parent;
          if (!inserted && !i2)
            isParent ? replaceNode(parent, node, el) : insertNode2(parent, node, marker);
          else
            isParent && removeNode(parent, el);
        } else
          inserted = true;
      }
    } else
      insertNode2(parent, node, marker);
    return [node];
  }
  function appendNodes(parent, array, marker) {
    for (let i2 = 0, len = array.length; i2 < len; i2++)
      insertNode2(parent, array[i2], marker);
  }
  function replaceNode(parent, newNode, oldNode) {
    insertNode2(parent, newNode, oldNode);
    removeNode(parent, oldNode);
  }
  function spreadExpression(node, props, prevProps = {}, skipChildren) {
    if (!skipChildren && "children" in props) {
      createRenderEffect(() => prevProps.children = insertExpression(node, props.children, prevProps.children));
    }
    createRenderEffect(() => {
      for (const prop in props) {
        if (prop === "children")
          continue;
        const value = props[prop];
        if (value === prevProps[prop])
          continue;
        if (prop === "ref")
          value(node);
        else {
          setProperty(node, prop, value, prevProps[prop]);
          prevProps[prop] = value;
        }
      }
    });
    return prevProps;
  }
  return {
    render(code, element) {
      let disposer;
      createRoot((dispose2) => {
        disposer = dispose2;
        insert2(element, code());
      });
      return disposer;
    },
    insert: insert2,
    spread(node, accessor, skipChildren) {
      if (typeof accessor === "function") {
        createRenderEffect((current) => spreadExpression(node, accessor(), current, skipChildren));
      } else
        spreadExpression(node, accessor, void 0, skipChildren);
    },
    createElement: createElement2,
    createTextNode: createTextNode2,
    insertNode: insertNode2,
    setProp(node, name, value, prev) {
      setProperty(node, name, value, prev);
      return value;
    },
    mergeProps: mergeProps$1,
    effect: createRenderEffect,
    memo: memo$1,
    createComponent: createComponent$1
  };
}
function mergeProps$1(...sources) {
  const target = {};
  for (let i2 = 0; i2 < sources.length; i2++) {
    let source = sources[i2];
    if (typeof source === "function")
      source = source();
    const descriptors = Object.getOwnPropertyDescriptors(source);
    Object.defineProperties(target, descriptors);
  }
  return target;
}
function createRenderer(options) {
  const renderer = createRenderer$1(options);
  renderer.mergeProps = mergeProps$2;
  return renderer;
}
let DEBUG = window.location.search.indexOf("debug") > -1;
function log(renderer, action, ...options) {
  DEBUG && console.debug(`%c${renderer} %s  %c`, "font-weight: bold", action, "font-weight: normal", ...options);
}
function createSolidRenderer({
  createInstance,
  applyProp: applyProp2,
  appendChild,
  insertBefore,
  removeChild,
  attach: attach2
}) {
  return createRenderer({
    createElement(element, args) {
      log("three", "createElement", element);
      if (element === "scene") {
        return prepare(new Scene());
      }
      let root = useContext(ThreeContext);
      return createInstance(element, {
        args
      }, root);
    },
    createTextNode(value) {
      return prepare({
        text: value,
        type: "text"
      });
    },
    replaceText(textNode, value) {
      throw new Error("Cant replace text node in three");
    },
    setProperty(node, key, value) {
      log("three", "setProperty", node, key, node[key], value);
      if (/^on(Pointer|Click|DoubleClick|ContextMenu|Wheel)/.test(key))
        return applyProp2(node, [key, value, true, []]);
      let entries = [];
      if (key.includes("-"))
        entries = key.split("-");
      applyProp2(node, [key, value, false, entries]);
      if (key === "attach" && node.__r3f.parent) {
        attach2(node.__r3f.parent, node, value);
      }
    },
    insertNode(parent, node, anchor) {
      log("three", "insertNode", parent, node, anchor);
      if (node instanceof Text) {
        return;
      }
      if (anchor) {
        insertBefore(parent, node, anchor);
      } else {
        appendChild(parent, node);
      }
    },
    isTextNode(node) {
      return node.type === "text";
    },
    removeNode(parent, node) {
      log("three", "removeNode", parent, node);
      removeChild(parent, node, true);
    },
    getParentNode(node) {
      log("three", "getParentNode", node);
      return node.__r3f.parent;
    },
    getFirstChild(node) {
      var _a;
      log("three", "getFirstChild", node);
      return ((_a = node.__r3f.objects) == null ? void 0 : _a.length) ? node.__r3f.objects[0] : node.children[0];
    },
    getNextSibling(node) {
      log("three", "getNextSibling", node);
      return node.nextSibling;
    }
  });
}
const DEFAULT = "__default";
const isDiffSet = (def) => def && !!def.changes;
function calculateDpr(dpr) {
  return Array.isArray(dpr) ? Math.min(Math.max(dpr[0], window.devicePixelRatio), dpr[1]) : dpr;
}
const is = {
  obj: (a) => a === Object(a) && !is.arr(a) && typeof a !== "function",
  fun: (a) => typeof a === "function",
  str: (a) => typeof a === "string",
  num: (a) => typeof a === "number",
  und: (a) => a === void 0,
  arr: (a) => Array.isArray(a),
  equ(a, b) {
    if (typeof a !== typeof b || !!a !== !!b)
      return false;
    if (is.str(a) || is.num(a) || is.obj(a))
      return a === b;
    if (is.arr(a) && a == b)
      return true;
    let i2;
    for (i2 in a)
      if (!(i2 in b))
        return false;
    for (i2 in b)
      if (a[i2] !== b[i2])
        return false;
    return is.und(i2) ? a === b : true;
  }
};
function buildGraph(object) {
  const data = { nodes: {}, materials: {} };
  if (object) {
    object.traverse((obj) => {
      if (obj.name)
        data.nodes[obj.name] = obj;
      if (obj.material && !data.materials[obj.material.name])
        data.materials[obj.material.name] = obj.material;
    });
  }
  return data;
}
function dispose(obj) {
  var _a;
  if (obj.dispose && obj.type !== "Scene")
    obj.dispose();
  for (const p in obj) {
    (_a = p.dispose) == null ? void 0 : _a.call(p);
    delete obj[p];
  }
}
function prepare(object, state) {
  const instance = object;
  if ((state == null ? void 0 : state.primitive) || !instance.__r3f) {
    instance.__r3f = __spreadValues({
      root: null,
      memoizedProps: {},
      eventCount: 0,
      handlers: {},
      objects: [],
      parent: null
    }, state);
  }
  return object;
}
function resolve(instance, key) {
  let target = instance;
  if (key.includes("-")) {
    const entries = key.split("-");
    const last = entries.pop();
    target = entries.reduce((acc, key2) => acc[key2], instance);
    return { target, key: last };
  } else
    return { target, key };
}
function attach(parent, child, type) {
  log("three", "attach", parent, child, type);
  if (is.str(type)) {
    const { target, key } = resolve(parent, type);
    parent.__r3f.previousAttach = target[key];
    target[key] = child;
  } else if (is.arr(type)) {
    const [attach2] = type;
    if (is.str(attach2))
      parent[attach2](child);
    else if (is.fun(attach2))
      attach2(parent, child);
  }
}
function detach(parent, child, type) {
  log("three", "detach", parent, child, type);
  if (is.str(type)) {
    const { target, key } = resolve(parent, type);
    if (child === parent.__r3f.previousAttach) {
      return;
    }
    target[key] = parent.__r3f.previousAttach;
  } else if (is.arr(type)) {
    const [, detach2] = type;
    if (is.str(detach2))
      parent[detach2](child);
    else if (is.fun(detach2))
      detach2(parent, child);
  }
}
function checkShallow(a, b) {
  if (is.arr(a) && is.equ(a, b))
    return true;
  if (a === b)
    return true;
  return false;
}
function diffProps(instance, _a, _c = {}, remove = false) {
  var _b = _a, { children: cN, key: kN, ref: rN } = _b, props = __objRest(_b, ["children", "key", "ref"]);
  var _d = _c, { children: cP, key: kP, ref: rP } = _d, previous = __objRest(_d, ["children", "key", "ref"]);
  var _a2;
  (_a2 = instance == null ? void 0 : instance.__r3f) != null ? _a2 : {};
  const entries = Object.entries(props);
  const changes = [];
  if (remove) {
    const previousKeys = Object.keys(previous);
    for (let i2 = 0; i2 < previousKeys.length; i2++) {
      if (!props.hasOwnProperty(previousKeys[i2]))
        entries.unshift([previousKeys[i2], DEFAULT + "remove"]);
    }
  }
  entries.forEach(([key, value]) => {
    var _a3;
    if (((_a3 = instance.__r3f) == null ? void 0 : _a3.primitive) && key === "object")
      return;
    if (checkShallow(value, previous[key]))
      return;
    if (/^on(Pointer|Click|DoubleClick|ContextMenu|Wheel)/.test(key))
      return changes.push([key, value, true, []]);
    let entries2 = [];
    if (key.includes("-"))
      entries2 = key.split("-");
    changes.push([key, value, false, entries2]);
  });
  return { changes };
}
function applyProps(instance, data) {
  var _a, _b;
  const localState = (_a = instance == null ? void 0 : instance.__r3f) != null ? _a : {};
  const root = localState.root;
  const rootState = (_b = root == null ? void 0 : root.getState()) != null ? _b : {};
  const { changes } = isDiffSet(data) ? data : diffProps(instance, data);
  const prevHandlers = localState.eventCount;
  changes.forEach((change) => {
    applyProp(instance, change, localState, rootState);
  });
  if (localState.parent && rootState.internal && instance.raycast && prevHandlers !== localState.eventCount) {
    const index = rootState.internal.interaction.indexOf(instance);
    if (index > -1)
      rootState.internal.interaction.splice(index, 1);
    if (localState.eventCount)
      rootState.internal.interaction.push(instance);
  }
  if (changes.length && instance.parent)
    updateInstance(instance);
}
function applyProp(instance, [key, value, isEvent, keys], localState = ((_e) => (_e = instance == null ? void 0 : instance.__r3f) != null ? _e : {})(), rootState = ((_f) => (_f = localState.root) == null ? void 0 : _f.getState())()) {
  let currentInstance = instance;
  let targetProp = currentInstance[key];
  if (keys.length) {
    targetProp = keys.reduce((acc, key2) => acc[key2], instance);
    if (!(targetProp && targetProp.set)) {
      const [name, ...reverseEntries] = keys.reverse();
      currentInstance = reverseEntries.reverse().reduce((acc, key2) => acc[key2], instance);
      key = name;
    }
  }
  if (value === DEFAULT + "remove") {
    if (targetProp && targetProp.constructor) {
      value = new targetProp.constructor();
    } else if (currentInstance.constructor) {
      const defaultClassCall = new currentInstance.constructor(currentInstance.__r3f.memoizedProps.args);
      value = defaultClassCall[targetProp];
      if (defaultClassCall.dispose)
        defaultClassCall.dispose();
    } else {
      value = 0;
    }
  }
  if (isEvent) {
    if (value)
      localState.handlers[key] = value;
    else
      delete localState.handlers[key];
    localState.eventCount = Object.keys(localState.handlers).length;
  } else if (targetProp && targetProp.set && (targetProp.copy || targetProp instanceof THREE.Layers)) {
    if (Array.isArray(value)) {
      if (targetProp.fromArray)
        targetProp.fromArray(value);
      else
        targetProp.set(...value);
    } else if (targetProp.copy && value && value.constructor && targetProp.constructor.name === value.constructor.name) {
      targetProp.copy(value);
    } else if (value !== void 0) {
      const isColor = targetProp instanceof THREE.Color;
      if (!isColor && targetProp.setScalar)
        targetProp.setScalar(value);
      else if (targetProp instanceof THREE.Layers && value instanceof THREE.Layers)
        targetProp.mask = value.mask;
      else
        targetProp.set(value);
      if (!rootState.linear && isColor)
        targetProp.convertSRGBToLinear();
    }
  } else {
    currentInstance[key] = value;
    if (!rootState.linear && currentInstance[key] instanceof THREE.Texture) {
      currentInstance[key].encoding = THREE.sRGBEncoding;
    }
  }
  if (rootState.internal && instance.raycast) {
    const index = rootState.internal.interaction.indexOf(instance);
    if (index > -1)
      rootState.internal.interaction.splice(index, 1);
    if (localState.eventCount)
      rootState.internal.interaction.push(instance);
  }
  invalidateInstance(instance);
  return { __return: instance, key, value };
}
function invalidateInstance(instance) {
  var _a, _b, _c;
  const state = (_c = (_b = (_a = instance.__r3f) == null ? void 0 : _a.root) == null ? void 0 : _b.getState) == null ? void 0 : _c.call(_b);
  if (state && state.internal.frames === 0)
    state.invalidate();
}
function updateInstance(instance) {
  var _a;
  (_a = instance.onUpdate) == null ? void 0 : _a.call(instance, instance);
}
function makeId(event) {
  return (event.eventObject || event.object).uuid + "/" + event.index + event.instanceId;
}
function releaseInternalPointerCapture(capturedMap, obj, captures, pointerId) {
  const captureData = captures.get(obj);
  if (captureData) {
    captures.delete(obj);
    if (captures.size === 0) {
      capturedMap.delete(pointerId);
      captureData.target.releasePointerCapture(pointerId);
    }
  }
}
function removeInteractivity(store, object) {
  const { internal } = store.getState();
  internal.interaction = internal.interaction.filter((o) => o !== object);
  internal.initialHits = internal.initialHits.filter((o) => o !== object);
  internal.hovered.forEach((value, key) => {
    if (value.eventObject === object || value.object === object) {
      internal.hovered.delete(key);
    }
  });
  internal.capturedMap.forEach((captures, pointerId) => {
    releaseInternalPointerCapture(internal.capturedMap, object, captures, pointerId);
  });
}
function createEvents(store) {
  const temp = new THREE.Vector3();
  function prepareRay(event) {
    var _a, _b;
    const state = store.getState();
    const { raycaster, mouse, camera, size } = state;
    const { offsetX, offsetY } = (_b = (_a = raycaster.computeOffsets) == null ? void 0 : _a.call(raycaster, event, state)) != null ? _b : event;
    const { width, height } = size;
    mouse.set(offsetX / width * 2 - 1, -(offsetY / height) * 2 + 1);
    raycaster.setFromCamera(mouse, camera);
  }
  function calculateDistance(event) {
    const { internal } = store.getState();
    const dx = event.offsetX - internal.initialClick[0];
    const dy = event.offsetY - internal.initialClick[1];
    return Math.round(Math.sqrt(dx * dx + dy * dy));
  }
  function filterPointerEvents(objects) {
    return objects.filter((obj) => ["Move", "Over", "Enter", "Out", "Leave"].some((name) => {
      var _a;
      return (_a = obj.__r3f) == null ? void 0 : _a.handlers["onPointer" + name];
    }));
  }
  function intersect(filter) {
    var _a;
    const state = store.getState();
    const { raycaster, internal } = state;
    if (!raycaster.enabled)
      return [];
    const seen = new Set();
    const intersections = [];
    const eventsObjects = filter ? filter(internal.interaction) : internal.interaction;
    let intersects = raycaster.intersectObjects(eventsObjects, true).filter((item) => {
      const id = makeId(item);
      if (seen.has(id))
        return false;
      seen.add(id);
      return true;
    });
    if (raycaster.filter)
      intersects = raycaster.filter(intersects, state);
    for (const intersect2 of intersects) {
      let eventObject = intersect2.object;
      while (eventObject) {
        if ((_a = eventObject.__r3f) == null ? void 0 : _a.eventCount)
          intersections.push(__spreadProps(__spreadValues({}, intersect2), { eventObject }));
        eventObject = eventObject.parent;
      }
    }
    return intersections;
  }
  function patchIntersects(intersections, event) {
    const { internal } = store.getState();
    if ("pointerId" in event && internal.capturedMap.has(event.pointerId)) {
      for (let captureData of internal.capturedMap.get(event.pointerId).values()) {
        intersections.push(captureData.intersection);
      }
    }
    return intersections;
  }
  function handleIntersects(intersections, event, delta, callback) {
    const { raycaster, mouse, camera, internal } = store.getState();
    if (intersections.length) {
      const unprojectedPoint = temp.set(mouse.x, mouse.y, 0).unproject(camera);
      const localState = { stopped: false };
      for (const hit of intersections) {
        const hasPointerCapture = (id) => {
          var _a, _b;
          return (_b = (_a = internal.capturedMap.get(id)) == null ? void 0 : _a.has(hit.eventObject)) != null ? _b : false;
        };
        const setPointerCapture = (id) => {
          const captureData = {
            intersection: hit,
            target: event.target
          };
          if (internal.capturedMap.has(id)) {
            internal.capturedMap.get(id).set(hit.eventObject, captureData);
          } else {
            internal.capturedMap.set(id, new Map([[hit.eventObject, captureData]]));
          }
          event.target.setPointerCapture(id);
        };
        const releasePointerCapture = (id) => {
          const captures = internal.capturedMap.get(id);
          if (captures) {
            releaseInternalPointerCapture(internal.capturedMap, hit.eventObject, captures, id);
          }
        };
        let extractEventProps = {};
        for (let prop in event) {
          let property = event[prop];
          if (typeof property !== "function")
            extractEventProps[prop] = property;
        }
        let raycastEvent = __spreadProps(__spreadValues(__spreadValues({}, hit), extractEventProps), {
          spaceX: mouse.x,
          spaceY: mouse.y,
          intersections,
          stopped: localState.stopped,
          delta,
          unprojectedPoint,
          ray: raycaster.ray,
          camera,
          stopPropagation: () => {
            const capturesForPointer = "pointerId" in event && internal.capturedMap.get(event.pointerId);
            if (!capturesForPointer || capturesForPointer.has(hit.eventObject)) {
              raycastEvent.stopped = localState.stopped = true;
              if (internal.hovered.size && Array.from(internal.hovered.values()).find((i2) => i2.eventObject === hit.eventObject)) {
                const higher = intersections.slice(0, intersections.indexOf(hit));
                cancelPointer([...higher, hit]);
              }
            }
          },
          target: {
            hasPointerCapture,
            setPointerCapture,
            releasePointerCapture
          },
          currentTarget: {
            hasPointerCapture,
            setPointerCapture,
            releasePointerCapture
          },
          sourceEvent: event,
          nativeEvent: event
        });
        callback(raycastEvent);
        if (localState.stopped === true)
          break;
      }
    }
    return intersections;
  }
  function cancelPointer(hits) {
    const { internal } = store.getState();
    Array.from(internal.hovered.values()).forEach((hoveredObj) => {
      var _a, _b;
      if (!hits.length || !hits.find((hit) => hit.object === hoveredObj.object && hit.index === hoveredObj.index && hit.instanceId === hoveredObj.instanceId)) {
        const eventObject = hoveredObj.eventObject;
        const instance = eventObject.__r3f;
        const handlers = instance == null ? void 0 : instance.handlers;
        internal.hovered.delete(makeId(hoveredObj));
        if (instance == null ? void 0 : instance.eventCount) {
          const data = __spreadProps(__spreadValues({}, hoveredObj), { intersections: hits || [] });
          (_a = handlers.onPointerOut) == null ? void 0 : _a.call(handlers, data);
          (_b = handlers.onPointerLeave) == null ? void 0 : _b.call(handlers, data);
        }
      }
    });
  }
  const handlePointer = (name) => {
    switch (name) {
      case "onPointerLeave":
      case "onPointerCancel":
        return () => cancelPointer([]);
      case "onLostPointerCapture":
        return (event) => {
          const { internal } = store.getState();
          if ("pointerId" in event && !internal.capturedMap.has(event.pointerId)) {
            internal.capturedMap.delete(event.pointerId);
            cancelPointer([]);
          }
        };
    }
    return (event) => {
      const { onPointerMissed, internal } = store.getState();
      prepareRay(event);
      internal.lastEvent.current = event;
      const isPointerMove = name === "onPointerMove";
      const isClickEvent = name === "onClick" || name === "onContextMenu" || name === "onDoubleClick";
      const filter = isPointerMove ? filterPointerEvents : void 0;
      const hits = patchIntersects(intersect(filter), event);
      const delta = isClickEvent ? calculateDistance(event) : 0;
      if (name === "onPointerDown") {
        internal.initialClick = [event.offsetX, event.offsetY];
        internal.initialHits = hits.map((hit) => hit.eventObject);
      }
      if (isClickEvent && !hits.length) {
        if (delta <= 2) {
          pointerMissed(event, internal.interaction);
          if (onPointerMissed)
            onPointerMissed(event);
        }
      }
      if (isPointerMove)
        cancelPointer(hits);
      handleIntersects(hits, event, delta, (data) => {
        var _a, _b, _c;
        const eventObject = data.eventObject;
        const instance = eventObject.__r3f;
        const handlers = instance == null ? void 0 : instance.handlers;
        if (!(instance == null ? void 0 : instance.eventCount))
          return;
        if (isPointerMove) {
          if (handlers.onPointerOver || handlers.onPointerEnter || handlers.onPointerOut || handlers.onPointerLeave) {
            const id = makeId(data);
            const hoveredItem = internal.hovered.get(id);
            if (!hoveredItem) {
              internal.hovered.set(id, data);
              (_a = handlers.onPointerOver) == null ? void 0 : _a.call(handlers, data);
              (_b = handlers.onPointerEnter) == null ? void 0 : _b.call(handlers, data);
            } else if (hoveredItem.stopped) {
              data.stopPropagation();
            }
          }
          (_c = handlers.onPointerMove) == null ? void 0 : _c.call(handlers, data);
        } else {
          const handler = handlers[name];
          if (handler) {
            if (!isClickEvent || internal.initialHits.includes(eventObject)) {
              pointerMissed(event, internal.interaction.filter((object) => !internal.initialHits.includes(object)));
              handler(data);
            }
          } else {
            if (isClickEvent && internal.initialHits.includes(eventObject)) {
              pointerMissed(event, internal.interaction.filter((object) => !internal.initialHits.includes(object)));
            }
          }
        }
      });
    };
  };
  function pointerMissed(event, objects) {
    objects.forEach((object) => {
      var _a, _b, _c;
      return (_c = (_a = object.__r3f) == null ? void 0 : (_b = _a.handlers).onPointerMissed) == null ? void 0 : _c.call(_b, event);
    });
  }
  return { handlePointer };
}
function createSubs(callback, subs) {
  const index = subs.length;
  subs.push(callback);
  return () => void subs.splice(index, 1);
}
let i;
let globalEffects = [];
let globalAfterEffects = [];
let globalTailEffects = [];
const addEffect = (callback) => createSubs(callback, globalEffects);
const addAfterEffect = (callback) => createSubs(callback, globalAfterEffects);
const addTail = (callback) => createSubs(callback, globalTailEffects);
function run(effects, timestamp) {
  for (i = 0; i < effects.length; i++)
    effects[i](timestamp);
}
function render$1(timestamp, state) {
  let delta = state.clock.getDelta();
  if (state.frameloop === "never" && typeof timestamp === "number") {
    delta = timestamp - state.clock.elapsedTime;
    state.clock.oldTime = state.clock.elapsedTime;
    state.clock.elapsedTime = timestamp;
  }
  for (i = 0; i < state.internal.subscribers.length; i++)
    state.internal.subscribers[i].ref(state, delta);
  if (!state.internal.priority && state.gl.render)
    state.gl.render(state.scene, state.camera);
  state.internal.frames = Math.max(0, state.internal.frames - 1);
  return state.frameloop === "always" ? 1 : state.internal.frames;
}
function createLoop(roots2) {
  let running = false;
  let repeat;
  function loop(timestamp) {
    running = true;
    repeat = 0;
    run(globalEffects, timestamp);
    roots2.forEach((root) => {
      var _a;
      const state = root.store.getState();
      if (state.internal.active && (state.frameloop === "always" || state.internal.frames > 0) && !((_a = state.gl.xr) == null ? void 0 : _a.isPresenting)) {
        repeat += render$1(timestamp, state);
      }
    });
    run(globalAfterEffects, timestamp);
    if (repeat > 0)
      return requestAnimationFrame(loop);
    else
      run(globalTailEffects, timestamp);
    running = false;
  }
  function invalidate2(state) {
    var _a;
    if (!state)
      return roots2.forEach((root) => invalidate2(root.store.getState()));
    if (((_a = state.gl.xr) == null ? void 0 : _a.isPresenting) || !state.internal.active || state.frameloop === "never")
      return;
    state.internal.frames = Math.min(60, state.internal.frames + 1);
    if (!running) {
      running = true;
      requestAnimationFrame(loop);
    }
  }
  function advance2(timestamp, runGlobalEffects = true, state) {
    if (runGlobalEffects)
      run(globalEffects, timestamp);
    if (!state)
      roots2.forEach((root) => render$1(timestamp, root.store.getState()));
    else
      render$1(timestamp, state);
    if (runGlobalEffects)
      run(globalAfterEffects, timestamp);
  }
  return { loop, invalidate: invalidate2, advance: advance2 };
}
const roots = new Map();
const {
  invalidate,
  advance
} = createLoop(roots);
const createRendererInstance = (gl, canvas) => {
  const customRenderer = typeof gl === "function" ? gl(canvas) : gl;
  if (isRenderer(customRenderer))
    return customRenderer;
  const renderer = new THREE.WebGLRenderer(__spreadValues({
    powerPreference: "high-performance",
    canvas,
    antialias: true,
    alpha: true
  }, gl));
  renderer.outputEncoding = THREE.sRGBEncoding;
  renderer.toneMapping = THREE.ACESFilmicToneMapping;
  if (gl)
    applyProps(renderer, gl);
  return renderer;
};
function createThreeRoot(canvas, config) {
  var _b, _c;
  let _a = config || {}, {
    gl,
    size,
    events,
    onCreated
  } = _a, props = __objRest(_a, [
    "gl",
    "size",
    "events",
    "onCreated"
  ]);
  if (!size) {
    size = (_c = (_b = canvas.parentElement) == null ? void 0 : _b.getBoundingClientRect()) != null ? _c : {
      width: 0,
      height: 0
    };
  }
  const glRenderer = createRendererInstance(gl, canvas);
  const store = createThreeStore(applyProps, invalidate, advance, __spreadValues({
    gl: glRenderer,
    size
  }, props));
  const state = store.getState();
  roots.set(canvas, {
    store
  });
  if (events)
    state.set({
      events: events(store)
    });
  createEffect(() => {
    var _a2, _b2;
    const state2 = store.getState();
    state2.set((state3) => ({
      internal: __spreadProps(__spreadValues({}, state3.internal), {
        active: true
      })
    }));
    (_b2 = (_a2 = state2.events).connect) == null ? void 0 : _b2.call(_a2, canvas);
    onCreated == null ? void 0 : onCreated(state2);
    state2.invalidate();
  });
  return store;
}
function unmountComponentAtNode(canvas, callback) {
  roots.get(canvas);
}
const isStore = (def) => def && !!def.getState;
let catalogue = {};
let extend = (objects) => void (catalogue = __spreadValues(__spreadValues({}, catalogue), objects));
function createThreeRenderer(roots2, getEventPriority) {
  function createInstance(type, _a, root) {
    var _b = _a, { args = [], attach: attach2 } = _b, props = __objRest(_b, ["args", "attach"]);
    let name = `${type[0].toUpperCase()}${type.slice(1)}`;
    let instance;
    if (!root || !isStore(root))
      throw `No valid root for ${name}!`;
    if (attach2 === void 0) {
      if (name.endsWith("Geometry"))
        attach2 = "geometry";
      else if (name.endsWith("Material"))
        attach2 = "material";
    }
    if (type === "primitive") {
      if (props.object === void 0)
        throw `Primitives without 'object' are invalid!`;
      const object = props.object;
      instance = prepare(object, {
        root,
        attach: attach2,
        primitive: true
      });
    } else {
      const target = catalogue[name];
      if (!target) {
        throw `${name} is not part of the THREE namespace! Did you forget to extend? See: https://github.com/pmndrs/react-three-fiber/blob/master/markdown/api.md#using-3rd-party-objects-declaratively`;
      }
      if (!Array.isArray(args))
        throw "The args prop must be an array!";
      instance = prepare(new target(...args), {
        root,
        attach: attach2,
        memoizedProps: { args: args.length === 0 ? null : args }
      });
    }
    applyProps(instance, props);
    return instance;
  }
  function appendChild(parentInstance, child) {
    let added = false;
    if (child) {
      if (child.__r3f.attach) {
        attach(parentInstance, child, child.__r3f.attach);
      } else if (child.isObject3D && parentInstance.isObject3D) {
        parentInstance.add(child);
        added = true;
      }
      if (!added)
        parentInstance.__r3f.objects.push(child);
      if (!child.__r3f)
        prepare(child, {});
      child.__r3f.parent = parentInstance;
      updateInstance(child);
      invalidateInstance(child);
    }
  }
  function insertBefore(parentInstance, child, beforeChild) {
    let added = false;
    if (child) {
      if (child.__r3f.attach) {
        attach(parentInstance, child, child.__r3f.attach);
      } else if (child.isObject3D && parentInstance.isObject3D) {
        child.parent = parentInstance;
        child.dispatchEvent({ type: "added" });
        const restSiblings = parentInstance.children.filter((sibling) => sibling !== child);
        const index = restSiblings.indexOf(beforeChild);
        parentInstance.children = [
          ...restSiblings.slice(0, index),
          child,
          ...restSiblings.slice(index)
        ];
        added = true;
      }
      if (!added)
        parentInstance.__r3f.objects.push(child);
      if (!child.__r3f)
        prepare(child, {});
      child.__r3f.parent = parentInstance;
      updateInstance(child);
      invalidateInstance(child);
    }
  }
  function removeRecursive(array, parent, dispose2 = false) {
    if (array)
      [...array].forEach((child) => removeChild(parent, child, dispose2));
  }
  function removeChild(parentInstance, child, canDispose) {
    var _a, _b, _c, _d, _e, _f;
    if (child) {
      if (child.__r3f)
        child.__r3f.parent = null;
      if ((_a = parentInstance.__r3f) == null ? void 0 : _a.objects)
        parentInstance.__r3f.objects = parentInstance.__r3f.objects.filter((x) => x !== child);
      if ((_b = child.__r3f) == null ? void 0 : _b.attach) {
        detach(parentInstance, child, child.__r3f.attach);
      } else if (child.isObject3D && parentInstance.isObject3D) {
        log("three", "removeObject", parentInstance, child);
        parentInstance.remove(child);
        if ((_c = child.__r3f) == null ? void 0 : _c.root) {
          removeInteractivity(child.__r3f.root, child);
        }
      }
      const isPrimitive = (_d = child.__r3f) == null ? void 0 : _d.primitive;
      const shouldDispose = canDispose === void 0 ? child.dispose !== null && !isPrimitive : canDispose;
      if (!isPrimitive) {
        removeRecursive((_e = child.__r3f) == null ? void 0 : _e.objects, child, shouldDispose);
        removeRecursive(child.children, child, shouldDispose);
      }
      if (child.__r3f) {
        delete child.__r3f.root;
        delete child.__r3f.objects;
        delete child.__r3f.handlers;
        delete child.__r3f.memoizedProps;
        if (!isPrimitive)
          delete child.__r3f;
      }
      if (shouldDispose && child.type !== "Scene") {
        try {
          log("three", "dispose", child);
          (_f = child.dispose) == null ? void 0 : _f.call(child);
          dispose(child);
        } catch (e) {
        }
      }
      invalidateInstance(parentInstance);
    }
  }
  function switchInstance(instance, type, newProps) {
    var _a;
    const parent = (_a = instance.__r3f) == null ? void 0 : _a.parent;
    if (!parent)
      return;
    const newInstance = createInstance(type, newProps, instance.__r3f.root);
    if (type !== "primitive" && instance.children) {
      instance.children.forEach((child) => appendChild(newInstance, child));
      instance.children = [];
    }
    instance.__r3f.objects.forEach((child) => appendChild(newInstance, child));
    instance.__r3f.objects = [];
    removeChild(parent, instance);
    appendChild(parent, newInstance);
  }
  return {
    applyProps,
    applyProp,
    appendChild,
    createInstance,
    switchInstance,
    insertBefore,
    removeChild,
    removeRecursive,
    attach
  };
}
const threeReconciler = createThreeRenderer();
const threeRenderer = createSolidRenderer(threeReconciler);
const {
  render,
  effect,
  memo,
  createComponent,
  createElement,
  createTextNode,
  insertNode,
  insert,
  spread,
  setProp,
  mergeProps
} = threeRenderer;
function Dynamic(props) {
  const [p, others] = splitProps(props, ["component"]);
  return createMemo(() => {
    const component = p.component;
    switch (typeof component) {
      case "function":
        return untrack(() => component(others));
      case "string":
        let el = createElement(component);
        spread(el, others, true);
        return el;
    }
  });
}
var threeTypes = /* @__PURE__ */ Object.freeze({
  __proto__: null,
  [Symbol.toStringTag]: "Module"
});
function useStore() {
  const store = useContext(ThreeContext);
  if (!store)
    throw `R3F hooks can only be used within the Canvas component!`;
  return store;
}
function useThree(selector = (state) => state, equalityFn) {
  let store = useStore();
  const [signal, setSignal] = createSignal(selector(store.getState()));
  createComputed(() => {
    let cleanup = useStore().subscribe(selector, (v) => {
      setSignal(() => v);
    }, equalityFn);
    onCleanup(cleanup);
  });
  return signal;
}
function useFrame(callback, renderPriority = 0) {
  const subscribe = useStore().getState().internal.subscribe;
  let cleanup = subscribe((t, delta) => untrack(() => callback(t, delta)), renderPriority);
  onCleanup(cleanup);
  return null;
}
function useGraph(object) {
  return createMemo(() => buildGraph(object));
}
function loadingFn(extensions, onProgress) {
  return function(Proto, ...input) {
    const loader = new Proto();
    if (extensions)
      extensions(loader);
    return Promise.all(input.map((input2) => new Promise((res, reject) => loader.load(input2, (data) => {
      if (data.scene)
        Object.assign(data, buildGraph(data.scene));
      res(data);
    }, onProgress, (error) => reject(`Could not load ${input2}: ${error.message}`)))));
  };
}
const DOM_EVENTS = {
  onClick: ["click", false],
  onContextMenu: ["contextmenu", false],
  onDoubleClick: ["dblclick", false],
  onWheel: ["wheel", true],
  onPointerDown: ["pointerdown", true],
  onPointerUp: ["pointerup", true],
  onPointerLeave: ["pointerleave", true],
  onPointerMove: ["pointermove", true],
  onPointerCancel: ["pointercancel", true],
  onLostPointerCapture: ["lostpointercapture", true]
};
function createPointerEvents(store) {
  const { handlePointer } = createEvents(store);
  return {
    connected: false,
    handlers: Object.keys(DOM_EVENTS).reduce((acc, key) => __spreadProps(__spreadValues({}, acc), { [key]: handlePointer(key) }), {}),
    connect: (target) => {
      var _a, _b;
      const { set, events } = store.getState();
      (_a = events.disconnect) == null ? void 0 : _a.call(events);
      set((state) => ({ events: __spreadProps(__spreadValues({}, state.events), { connected: target }) }));
      Object.entries((_b = events == null ? void 0 : events.handlers) != null ? _b : []).forEach(([name, event]) => {
        const [eventName, passive] = DOM_EVENTS[name];
        target.addEventListener(eventName, event, { passive });
      });
    },
    disconnect: () => {
      var _a;
      const { set, events } = store.getState();
      if (events.connected) {
        Object.entries((_a = events.handlers) != null ? _a : []).forEach(([name, event]) => {
          if (events && events.connected instanceof HTMLElement) {
            const [eventName] = DOM_EVENTS[name];
            events.connected.removeEventListener(eventName, event);
          }
        });
        set((state) => ({ events: __spreadProps(__spreadValues({}, state.events), { connected: false }) }));
      }
    }
  };
}
const _tmpl$ = template(`<canvas></canvas>`, 2), _tmpl$2 = template(`<div></div>`, 2);
extend(THREE);
function Canvas(props) {
  props = mergeProps$2({
    height: "100vh",
    width: "100vw"
  }, props);
  let canvas = (() => {
    const _el$ = _tmpl$.cloneNode(true);
    _el$.style.setProperty("height", "100%");
    _el$.style.setProperty("width", "100%");
    return _el$;
  })();
  let containerRef = (() => {
    const _el$2 = _tmpl$2.cloneNode(true);
    _el$2.style.setProperty("position", "relative");
    _el$2.style.setProperty("overflow", "hidden");
    insert$1(_el$2, canvas);
    effect$1((_p$) => {
      const _v$ = props.id, _v$2 = props.class, _v$3 = props.height, _v$4 = props.width, _v$5 = props.tabIndex;
      _v$ !== _p$._v$ && setAttribute(_el$2, "id", _p$._v$ = _v$);
      _v$2 !== _p$._v$2 && (_el$2.className = _p$._v$2 = _v$2);
      _v$3 !== _p$._v$3 && _el$2.style.setProperty("height", _p$._v$3 = _v$3);
      _v$4 !== _p$._v$4 && _el$2.style.setProperty("width", _p$._v$4 = _v$4);
      _v$5 !== _p$._v$5 && setAttribute(_el$2, "tabindex", _p$._v$5 = _v$5);
      return _p$;
    }, {
      _v$: void 0,
      _v$2: void 0,
      _v$3: void 0,
      _v$4: void 0,
      _v$5: void 0
    });
    return _el$2;
  })();
  const root = createThreeRoot(canvas, {
    events: createPointerEvents,
    size: containerRef.getBoundingClientRect(),
    camera: props.camera,
    shadows: props.shadows
  });
  new ResizeObserver((entries) => {
    var _a;
    if (((_a = entries[0]) == null ? void 0 : _a.target) !== containerRef)
      return;
    root.getState().setSize(entries[0].contentRect.width, entries[0].contentRect.height);
  }).observe(containerRef);
  insert(root.getState().scene, createComponent$2(ThreeContext.Provider, {
    value: root,
    get children() {
      return props.children;
    }
  })());
  onCleanup(() => {
    log("three", "cleanup");
    threeReconciler.removeRecursive(root.getState().scene.children, root.getState().scene, true);
    root.getState().scene.clear();
  });
  return containerRef;
}
export { Canvas, Dynamic, threeTypes as ThreeJSX, roots as _roots, addAfterEffect, addEffect, addTail, advance, applyProps, catalogue, ThreeContext as context, createComponent, createElement, createTextNode, createThreeRenderer, createThreeRoot, dispose, effect, createPointerEvents as events, extend, insert, insertNode, invalidate, loadingFn, memo, mergeProps, prepare, render, roots, setProp, spread, threeReconciler, threeRenderer, unmountComponentAtNode, useFrame, useGraph, useStore, useThree };
